#!/usr/bin/env python

import example

n = 3

print('double allocation and initialization in Python')
data = example.double_array(n)
for i in range(0,n):
    data[i] = i**2

print('passing doubles to C')
example.print_array(n, data)
example.print_pointer(n, data)
vector = example.double_vector_t()
vector.n = n
vector.data = data
example.print_vector(vector)

print('accessing doubles from Python')
print(data[n-1])
try:
    print(vector.data[n-1])
except TypeError, e:
    # 'SwigPyObject' object is not subscriptable
    print e
print(example.double_array.frompointer(vector.data)[n-1])

print('sample_t allocation and initialization in Python')
data = example.sample_array(n)
for i in range(0,n):
    data[i] = 2*i

print('passing sample_ts to C')
try:
    example.print_sample_pointer(n, data)
except TypeError, e:
    # in method 'print_sample_pointer', argument 2 of type 'sample_t *'
    print(e)
try:
    example.print_sample_array(n, data)
except TypeError, e:
    # in method 'print_sample_array', argument 2 of type 'sample_t []'
    print e

# the .cast() method lets you pass sample_t data to the funtion
example.print_sample_pointer(n, data.cast())
example.print_sample_array(n, data.cast())

vector = example.sample_vector_t()
vector.n = n
try:
    vector.data = data
except TypeError, e:
    # in method 'sample_vector_t_data_set', argument 2 of type 'sample_t *'
    print e
vector.data = data.cast()
example.print_sample_vector(vector)

print('accessing sample_ts from Python')
print(data[n-1])
try:
    print(vector.data[n-1])
except TypeError, e:
    # 'SwigPyObject' object is not subscriptable
    print e
print(example.sample_array.frompointer(vector.data)[n-1])
